//------------------------------------------------------------------------------
// Paul Dibden 
// BA(HONS)Computer Visualisation & Animation 2004
// Innovations - Pen & Ink Outline shader
//------------------------------------------------------------------------------

surface peninkoutliner( float near = 0;
			      float far = 1;
	     	          )

{
	vector V = -normalize(I);

	float sil_detect;	//silhouette detected with normal dotted with V.
	float depth;	//z-depth for edge classification.

	depth = 1.0 - clamp((depth(P) - near)/(far - near), 0.0, 1);
	//For aiding in extracting internal silhouettes of objects.

	sil_detect = N.V;	//silhouette detected with normal dotted with eye vector(V).
	sil_detect = (sil_detect * sil_detect)/(N.N * V.V);
	sil_detect = 1.0 - sqrt(sil_detect);

        Ci = color (sil_detect, depth, 0);	
	//silhouette detection and z-depth are encoded in red and green channels.
        Oi = 1.0;
}


